# TP Swing noté : le morpion

Dans ce TP, on met en place une implémentation MVC d'un jeu de Morpion :

![](images/morpion1.png)


Pour vous faire gagner du temps, un squelette vous est fourni. On vous fournit aussi un jeu de test pour le modèle. 

## Tour d'horizon des classes

À l'origine, nous avions pensé à utiliser une seule classe pour représenter le jeu de morpion. Cette classe modélisait à la fois le jeu (à qui de jouer, qui gagne, etc...) et son plateau. 

Il est rapidement apparu que ce n'était pas pratique : pour tester l'affichage du plateau, il était nécessaire de *simuler* une partie, ce qui était pénible, et liait le code de l'affichage aux règles du jeu.

Du coup, dans ce sujet, nous utilisons d'utiliser **deux** modèles complémentaires : `PlateauMorpionModele` qui représente un plateau de morpion sur lequel on peut poser librement des pions, et `JeuMorpionModele` qui représente une *partie* de morpion, et garantit que seuls des coups « légaux » seront joués.

Avec des modifications minimes, le `PlateauMorpionModele` pourrait être utilisé pour de nombreux autres jeux (dames, puissance4...)

## Question 1

Modifiez  `JMorpion`  pour qu'il affiche correctement le plateau *vide* (les lignes noires) :

![](images/morpionVide.png)

## Question 2

Modifiez  `JMorpion`  pour qu'il affiche correctement un plateau contenant des pions.

Pour ce développement, vous pouvez, dans le constructeur de`JMorpion`, initialiser le modèle pour qu'il contienne déjà quelques pions.

Note: pour rester cohérent avec la méthode `getCase` que nous fournissons (et parce que c'est en fait plus facile), considérez que la case (0,0) est située en haut à gauche, et la case (3,3) en bas à droite.

## Question 3

Modifiez `JeuMorpionModele` pour que la méthode `jouer()` fonctionne. Vous pouvez vous aider des tests fournis.

## Question 4

Modifiez `ApplicationMorpion` pour que les joueurs puissent jouer en cliquant sur les cases du plateau.


- Nous avons déjà prévu un mouseListener dans la classe; il vous reste à écrire le code appelé par `mousePressed`. Il pourra recevoir un `MouseEvent` lors d'un clic de souris.

- Vous devrez peut-être vous aussi écrire dans les autres classe le code correct pour que `PlateauMorpionModele` et `JMorpion` fonctionnent en architecture Observateur/Observable (Vue et Modèle).

- Si vous trouvez l'architecture Observateur/Observable trop complexe, vous pouvez éventuellement vous contenter d'appeler `repaint()` depuis le contrôleur (le mouse listener). 

- Notez l'existance de la méthode `getCase()` dans `JMorpion.` Elle pourra vous servir pour retrouver la case qui a été cochée à partir des coordonnées du clic de souris.

## Question 5

Arrangez-vous pour que le champ texte en bas, destiné aux messages du jeu, soit correctement rempli. Il doit afficher :

- le numéro du joueur qui doit jouer ;
- un message en fin de partie pour indiquer le résultat (joueur 1 gagne, joueur 2 gagne, match nul) ;
- si le joueur essaie de jouer dans une case occupée, un message « case occupée ».

