package morpion;

import morpion.modele.plateau.PlateauMorpionListener;
import morpion.modele.plateau.PlateauMorpionModele;
import morpion.modele.plateau.Case;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Point;
import javax.swing.JPanel;

/**
 * Visualisation graphique d'un plateau de jeu de morpion.
 *
 * @author rosmord
 */
public class JMorpion extends JPanel {

    private PlateauMorpionModele plateauMorpion;

    /**
     * Taille d'une case (en pixels)
     */
    private int tailleCase = 100;
    /**
     * Taille d'un pion (en pixels)
     */
    private int taillePion = 80;

    public JMorpion(PlateauMorpionModele plateauMorpion) {
        setBackground(Color.WHITE);
        setModele(plateauMorpion);
    }

    public JMorpion() {

    }

    public final void setModele(PlateauMorpionModele plateauMorpion) {
        throw new RuntimeException("ECRIVEZ-MOI !!!");
    }

    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);
        throw new RuntimeException("ECRIVEZ-MOI !!!");
    }

    @Override
    public Dimension getPreferredSize() {
        return new Dimension(3*tailleCase, 3*tailleCase);
    }

    /**
     * Retourner une case correspondant à un point. typiquement, le point sur
     * lequel on a cliqué.
     *
     * @param p
     * @return
     */
    public Case getCase(Point p) {
        int i = p.x / tailleCase;
        int j = p.y / tailleCase;
        if (i > 2) {
            i = 2;
        }
        if (j > 2) {
            j = 2;
        }
        return plateauMorpion.getCase(i, j);
    }

}
