package morpion.modele.plateau;

/**
 * Une case du plateau de jeu (et son contenu).
 * @author rosmord
 */
public class Case {

    private int ligne, colonne;
    private ContenuCase contenu;

    public Case(int ligne, int colonne, ContenuCase contenu) {
        this.ligne = ligne;
        this.colonne = colonne;
        this.contenu = contenu;
    }

    public ContenuCase getContenu() {
        return contenu;
    }

    public int getLigne() {
        return ligne;
    }

    public int getColonne() {
        return colonne;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 97 * hash + this.ligne;
        hash = 97 * hash + this.colonne;
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Case other = (Case) obj;
        if (this.ligne != other.ligne) {
            return false;
        }
        if (this.colonne != other.colonne) {
            return false;
        }
        return true;
    }

}
