/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package morpion;

import morpion.modele.partie.JeuMorpionModele;
import morpion.modele.plateau.PlateauMorpionModele;
import morpion.modele.plateau.ContenuCase;
import morpion.modele.partie.EtatJeu;
import morpion.modele.partie.MorpionException;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author rosmord
 */
public class JeuMorpionModeleTest {

    public JeuMorpionModeleTest() {
    }

    /**
     * Test of getPion method, of class JeuMorpionModele.
     *
     * @throws morpion.MorpionException
     */
    @Test
    public void testGetPion() throws MorpionException {
        JeuMorpionModele instance = new JeuMorpionModele(new PlateauMorpionModele());
        instance.jouer(1, 1);
        assertEquals(ContenuCase.VIDE, instance.getPion(0, 0));
        assertEquals(ContenuCase.PION1, instance.getPion(1, 1));
        assertEquals(ContenuCase.VIDE, instance.getPion(1, 3));
        assertEquals(ContenuCase.VIDE, instance.getPion(10, 3));
        assertEquals(ContenuCase.VIDE, instance.getPion(-1, -1));
    }

    /**
     * Test of jouer method, of class JeuMorpionModele.
     * @throws java.lang.Exception
     */
    @Test
    public void testJouer() throws Exception {
        JeuMorpionModele instance = new JeuMorpionModele(new PlateauMorpionModele());
        instance.jouer(0, 0);
        instance.jouer(1, 1);
        instance.jouer(0, 1);
        assertEquals(ContenuCase.PION1, instance.getPion(0, 0));
        assertEquals(ContenuCase.PION1, instance.getPion(0, 1));
        assertEquals(ContenuCase.PION2, instance.getPion(1, 1));
    }

    @Test(expected = MorpionException.class)
    public void testJouer1() throws Exception {
        JeuMorpionModele instance = new JeuMorpionModele(new PlateauMorpionModele());
        instance.jouer(0, 0);
        instance.jouer(1, 1);
        instance.jouer(0, 0);
    }

    @Test(expected = MorpionException.class)
    public void testJouer2() throws Exception {
        JeuMorpionModele instance = new JeuMorpionModele(new PlateauMorpionModele());
        instance.jouer(3, 0);
    }

    /**
     * Test of getEtatJeu method, of class JeuMorpionModele.
     *
     * @throws morpion.modele.partie.MorpionException
     */
    @Test
    public void testGetEtatJeuEnCours() throws MorpionException {
        JeuMorpionModele instance = new JeuMorpionModele(new PlateauMorpionModele());
        instance.jouer(0, 0);
        instance.jouer(1, 1);
        instance.jouer(0, 1);
        assertEquals(EtatJeu.EN_COURS, instance.getEtatJeu());
    }


    /**
     * Test of getJoueurCourant method, of class JeuMorpionModele.
     *
     * @throws morpion.modele.partie.MorpionException
     */
    @Test
    public void testGetJoueurCourant() throws MorpionException {
        JeuMorpionModele instance = new JeuMorpionModele(new PlateauMorpionModele());
        instance.jouer(1, 1);
        assertEquals(2, instance.getJoueurCourant());
    }

    @Test
    public void testPartie1() throws MorpionException {
        JeuMorpionModele instance = new JeuMorpionModele(new PlateauMorpionModele());
        instance.jouer(1, 1);
        assertEquals(EtatJeu.EN_COURS, instance.getEtatJeu());
        instance.jouer(0, 2);
        assertEquals(EtatJeu.EN_COURS, instance.getEtatJeu());
        // Erreur du joueur 1:
        try {
            instance.jouer(0, 2);
            fail("case interdite non détectée ???");
        } catch (MorpionException e) {
            // ok...
        }
        // Joueur 1 joue en 0,0
        instance.jouer(0, 0);
        assertEquals(EtatJeu.EN_COURS, instance.getEtatJeu());
        // Joueur 2 joue en 1,0
        instance.jouer(1, 0);
        instance.jouer(2, 2);
        // Joueur 1 gagne...
        assertEquals(EtatJeu.JOUEUR1_GAGNE, instance.getEtatJeu());
    }

    @Test
    public void testPartie2() throws MorpionException {
        // 112
        // 221
        // 121
        JeuMorpionModele instance = new JeuMorpionModele(new PlateauMorpionModele());
        partieNulle(instance);
        assertEquals(EtatJeu.MATCH_NUL, instance.getEtatJeu());
    }

    private void partieNulle(JeuMorpionModele instance) throws MorpionException {
        instance.jouer(0, 0);
        instance.jouer(1, 0);
        instance.jouer(0, 1);
        instance.jouer(1, 1);
        instance.jouer(1, 2);
        instance.jouer(0, 2);
        instance.jouer(2, 0);
        instance.jouer(2, 1);
        instance.jouer(2, 2);
    }
}
